"rake test:coverage" fails in Ruby 2.5 and 2.6

2019-03-05 10:18 - Go MAEDA

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Ruby support Estimated time: 0.00 hour

Target version: 4.1.0   

Resolution: Fixed Affected version:  

Description

rake test:coverage fails in Ruby 2.5 or 2.6 with the error like the following. It occurs due to Unicode characters such as 'ŋ' in

app/models/repository/git.rb line 3 and '汉' in lib/redmine/search.rb line 63.

Traceback (most recent call last):

    9: from /Users/maeda/redmines/gems/ruby/2.5.0/gems/simplecov-0.14.1/lib/simplecov/defaults.rb:

68:in `block in <top (required)>'

    8: from /Users/maeda/redmines/gems/ruby/2.5.0/gems/simplecov-0.14.1/lib/simplecov/configuratio

n.rb:180:in `block in at_exit'

    7: from /Users/maeda/redmines/gems/ruby/2.5.0/gems/simplecov-0.14.1/lib/simplecov/result.rb:46

:in `format!'

    6: from /Users/maeda/redmines/redmine-trunk/test/coverage/html_formatter.rb:29:in `format'

    5: from /Users/maeda/redmines/redmine-trunk/test/coverage/html_formatter.rb:29:in `each'

    4: from /Users/maeda/redmines/redmine-trunk/test/coverage/html_formatter.rb:30:in `block in fo

rmat'

    3: from /Users/maeda/redmines/redmine-trunk/test/coverage/html_formatter.rb:30:in `open'

    2: from /Users/maeda/redmines/redmine-trunk/test/coverage/html_formatter.rb:31:in `block (2 le

vels) in format'

    1: from /Users/maeda/redmines/redmine-trunk/test/coverage/html_formatter.rb:31:in `puts'

/Users/maeda/redmines/redmine-trunk/test/coverage/html_formatter.rb:31:in `write': "\xC5" from ASC

II-8BIT to UTF-8 (Encoding::UndefinedConversionError)

 You can fix the error with the following change.

Index: test/coverage/html_formatter.rb

===================================================================

--- test/coverage/html_formatter.rb    (リビジョン 17927)

+++ test/coverage/html_formatter.rb    (作業コピー)

@@ -28,7 +28,7 @@

         end

         result.source_files.each do |source_file|

           File.open(File.join(output_path, source_file_result(source_file)), "w") do |file|

-            file.puts template('source').result(binding)

+            file.puts template('source').result(binding).force_encoding('utf-8')

           end

         end

       end

Related issues:

Related to Redmine - Feature #30963: Update simplecov gem (~> 0.17.0) Closed

Associated revisions

Revision 17938 - 2019-03-10 00:28 - Go MAEDA

"rake test:coverage" fails in Ruby 2.5 and 2.6 (#30967).

Patch by Go MAEDA.

Revision 18120 - 2019-05-04 03:24 - Go MAEDA

"rake test:coverage" fails in Ruby 2.5 and 2.6 (#30967).

This commit fixes a wrong change done in r17938.
History

#1 - 2019-03-05 10:47 - Go MAEDA

- Related to Feature #30963: Update simplecov gem (~> 0.17.0) added

#2 - 2019-03-08 04:35 - Go MAEDA

- Subject changed from rake test:coverage fails in Ruby 2.5 or 2.6 to rake test:coverage fails in Ruby 2.5 and 2.6

- Target version changed from Candidate for next major release to 4.1.0

#3 - 2019-03-10 00:42 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed.

#4 - 2019-03-10 03:07 - Go MAEDA

- Subject changed from rake test:coverage fails in Ruby 2.5 and 2.6 to "rake test:coverage" fails in Ruby 2.5 and 2.6
